<?php
/*

 $Id: login.php,v 1.49 2003/12/05 00:20:47 vollmerk Exp $
 $Source: /data/cvsroot/maintain/docs/login.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Login page
	This is what will authenticate the user the first time.
*/

require "../modules/config.php";

$conf['script'] = "login.php";
$conf['error'] = new Error();

if ( $_SESSION[libglue_param('sess_name')] ) {
        $sql       = "SELECT value FROM session WHERE id='" . $_SESSION[libglue_param('sess_name')] . "'";
        $db_result = mysql_query($sql, $conf['dbh']);

        $session = mysql_fetch_object($db_result);

        if ( $session->value ) {

		//do a checksession so that we get the user mojo set
		check_session();

		//first see if the autoreg module is enabled. If not then just pass the bozoes in
		if ( $conf['modules']->modules['autoreg']->enabled ) {

			//we need to check and see if they have access to any zones if they don't then we need
			//to point them off to a different page (autoreg)
	
			//They've got access to one zone at least do the normal thing
			if (count($user->zones())) { 	

		                header("Location: " . $conf['web_path'] . "/index.php");
				exit();
			}
			else {
				header("Location: " . $conf['web_path'] . "/" . $conf['module_autoreg_web_root']);
				exit();
			} //end else

		} //end check for enabled module

		else { 

			header("Location: " . $conf['web_path']);
			exit();

		} //end checking for module
        }
}

if ( $_POST['username'] and $_POST['password'] ) {

	// Just incase let's go ahead and trim the username
	$_POST['username'] = trim($_POST['username']);

	if ( $conf['debug'] ) {
		$auth['success'] = 1;
	}
	else {
		// this calls either the proper authentication driver
		$auth = authenticate($_POST['username'],$_POST['password']);
	}
	
	if ( $auth['success'] == 1) {

		// let's register the session variables
		//   which will also start the session for the user

		if ( $conf['debug'] ) {
			$fullname = "Test User";
		}
		else {
			$fullname = $auth->fullname;
		}

		// the user object will be stored in the session db
		$user = new User($_POST['username'], $fullname, "login");

		// if the user doesn't have a ui_size set we need
		//    to set one so it doesn't look silly
		if (!$user->ui_size) { 
			$user->ui_size = 12; 
		}

		// this will register these variables for this
		//  user with this session

		make_local_session_only($auth);
		$_SESSION['user'] = $user;
	      
	      if ( $conf['modules']->modules['autoreg']->enabled && !count($user->zones())) { 

                        //we need to check and see if they have access to any zones if they don't then we need
                        //to point them off to a different page (autoreg)
                        header("Location: " . $conf['web_path'] . "/" . $conf['module_autoreg_web_root']);
			exit();
                } //end check for enabled module

                else {
                        header("Location: " . $conf['web_path'] . "/index.php");
			exit();

                } //end checking for module

	}
	else {
		$conf['error']->add_error('auth',$auth->error);
	}
}

// Now we need to see if Autoreg is on
if ($conf['modules']->modules['autoreg']->enabled && !$autoreg_login && !$conf['error']->status) {
	
	$ip = new IP(0);
	$source_ip = $ip->ip2int($_SERVER['REMOTE_ADDR']);
	$info = $conf['modules']->get_info('autoreg');

	foreach ($info['site'] as $site_name) {
	
		if ($info['free_start'][$site_name] <= $source_ip && $info['free_end'][$site_name] >= $source_ip) {
			$conf['color'] = new Color('generic');
			$user->autoreg_type = $site_name;
			header("Location: " . $conf['web_path'] . "/modules/why.php");
		}

	} // end foreach site
	

} // autoreg-enabled

// need to set this so we have the default font size for the
//   login screen
if (!$user->ui_size) { $user->ui_size = 12; }

require ($conf['prefix'] . "/templates/login_template.inc"); 

?>
